
QGIS Application - Bug report #16770

copy/paste/save features  from one layer to another of the same time broke in 2.18

2017-06-30 10:07 AM - Gerhard Spieles

Status: Closed

Priority: High

Assignee:

Category: Digitising

Affected QGIS version:2.18.10 Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 24669

Description

Copy an oject from one Layer and insert this object inot another layer works. Saving this changes in the layer fails and qgis reports

"Commit errors: Could not commit changes to layer 2_18_10_copyobjectto",  open the complete error message result is:

"Could not commit changes to layer 2_18_10_copyobjectto

Errors: ERROR: 1 feature(s) not added - geometry type is not compatible with the current layer."

Both shape layer are polygons, created with QGIS2.18.10

Testproject with layers are attached, also screenshots.

Related issues:

Related to QGIS Application - Bug report # 16758: regression: adding a multi-... Closed 2017-06-27

Related to QGIS Application - Bug report # 16948: "Paste features as..." alwa... Closed 2017-08-01

Associated revisions

Revision d19ed1c6 - 2017-07-05 06:50 PM - Jürgen Fischer

Only convert geometries to provider type when provider does strict type checking (ie. not for shapes; fixes #16593, #16784, #16792, #16770, followup

53d90b547)

Revision ecae3c95 - 2017-07-05 07:08 PM - Jürgen Fischer

Only convert geometries to provider type when provider does strict type checking

(ie. not for shapes; fixes #16593, #16784, #16792, #16770;

followup 87116abd72; forward ported from d19ed1c6)

History

#1 - 2017-07-02 11:05 AM - Gerhard Spieles

- Affected QGIS version changed from master to 2.18.10

#2 - 2017-07-03 01:36 AM - Giovanni Manghi

- Subject changed from shape, copy objects from one layer and insert into another layer fails, QGIS 2.18.10 reports  ERROR: 1 feature(s) not added - 

geometry type is not compatible with the current layer. to copy/paste/save features  from one layer to another of the same time broke in 2.18

- Operating System deleted (win 7)

- Regression? changed from No to Yes
Regression, worked as expected in 2.14

#3 - 2017-07-03 01:39 AM - Giovanni Manghi

- Category changed from Data Provider/OGR to Digitising

#4 - 2017-07-03 01:41 AM - Giovanni Manghi

Despite the error it seems the edits/pasted features are saved anyway.

In the log it shows this message that does not smell very well

2017-07-03T00:40:15    1    Unbalanced call to leaveUpdateMode() w.r.t. enterUpdateMode()

#5 - 2017-07-03 01:23 PM - Gerhard Spieles

copy and paste works fine also in QGIS 2.18.9.

#6 - 2017-07-05 09:57 AM - Hynek Suchy

I can confirm the issue.

I have installed QGIS 2.18.10 on Windows 10 machine.

Objects which I was copying were lines in ESRI shapefiles, (actually I have imported dxf file into QGIS and then trying to copy lines into existing shapefile).

Copying objects from one layer to the other was completed succesfully but on saving layer, there was error message something like: feature(s) not added -

geometry type is not compatible with the current layer and I wasn't able to save changes to layer.

After that I switched back to 2.18.9. and there everything works fine.

#7 - 2017-07-05 06:23 PM - Jürgen Fischer

- Related to Bug report #16758: regression: adding a multi-part feature to a shapefile dataset fails added

#8 - 2017-07-05 06:51 PM - Jürgen Fischer

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|d19ed1c627ac43c7a00221f5cb637b8b049f6681.

#9 - 2017-07-30 02:05 PM - Pedro Neves

It seems to be present in QGIS 2.18.11. All the same symptoms as described by Hynek Suchy. I'm on Arch Linux...

#10 - 2017-07-30 02:11 PM - Giovanni Manghi

Pedro Neves wrote:

It seems to be present in QGIS 2.18.11. All the same symptoms as described by Hynek Suchy. I'm on Arch Linux...
please post your datasets (or samples of them), thanks

#11 - 2017-07-30 07:17 PM - Pedro Neves

I would, but the dxf's are too big. I'll see if I can reduce the features on them..

#12 - 2017-07-30 07:20 PM - Pedro Neves

Giovanni: I've found a smaller file. How can I send it to you?

#13 - 2017-07-31 05:42 PM - Giovanni Manghi

Pedro Neves wrote:

Giovanni: I've found a smaller file. How can I send it to you?

giovanni dot manghi at gmail dot com

#14 - 2017-07-31 07:58 PM - Pedro Neves

File sent.

Thanks for your help.

Pedro

#15 - 2017-07-31 09:46 PM - Gerhard Spieles

I test it with 2.18.11 under win10 and win7.

Copy and paste between shape/shape and shape/spatialite is ok.

I haven`t test it with dxf/geopackage.

#16 - 2017-08-01 06:41 PM - Giovanni Manghi

see #16948

#17 - 2017-08-02 11:38 AM - Jürgen Fischer

- Related to Bug report #16948: "Paste features as..." always creates vector layer/scratch layer that can only handle just singlepart features, so pasting 

multipart features always returns an error added

Files

testshpaddpolygonfail.zip 7.09 KB 2017-06-30 Gerhard Spieles

2_18_10_shp_copy_object_insert_ok.jpg 97.6 KB 2017-06-30 Gerhard Spieles

2_18_10_shp_copy_object_save_fails.jpg 89.9 KB 2017-06-30 Gerhard Spieles
